import cgi
import os
import sha
from django.utils import simplejson as json
from time import time
from datetime import datetime
from google.appengine.api import memcache
from google.appengine.ext import webapp
from google.appengine.ext.webapp.util import run_wsgi_app
from google.appengine.ext import db
from google.appengine.ext.webapp import template
from google.appengine.api import mail



class MainPage(webapp.RequestHandler):
    def get(self):
        # Fill in with code to load up your frontend
        path=os.path.join(os.path.dirname(__file__), 'index.html')
        self.response.out.write(template.render(path,''))

# given a userid, pump the view list data out as json so that it can be called via ajax		
class ViewList(webapp.RequestHandler):
    def get(self):
        # for now, the page is using default class list values - need to add backend implementation
		# get the data for uid='', query the datastore, 
        path=os.path.join(os.path.dirname(__file__), 'viewlist.html')
        self.response.out.write(template.render(path,''))		
		


class ListRooms(webapp.RequestHandler):
    def get(self):
        q = ChatRoom.all()
        list = {}
        rooms = q.fetch(1000)
        cursor = q.cursor()
        while rooms != []:
            for r in rooms:
                list[str(r.key())] = cgi.escape(r.name)
            if cursor:
                q.with_cursor(cursor)
                rooms = q.fetch(1000)
                cursor = q.cursor()
        self.response.out.write(json.dumps(list))
    def post(self):
        ListRooms.get(self)

application = webapp.WSGIApplication(
                                     [('/', MainPage),
									  ('/API/view_list',ViewList),
                                      ('/API/list_rooms', ListRooms)
                                     ],
                                     debug=True)

def main():
    run_wsgi_app(application)

if __name__ == "__main__":
    main()

